Skip to navigation

Preview a subscription

View as Markdown

The REST API reference describes how to create a new subscription in preview mode. This call does not require a valid customer account. It can be used to show potential new customers a preview of a subscription with complete details and charges before creating an account, or to let existing customers preview a subscription with all charges before committing.

Notes:

  • The response of the Preview Subscription call is based on the REST API minor version you set in the request header. The response structure might be different if you use different minor version numbers.

  • If you have the Invoice Settlement feature enabled, we recommend that you set the Zuora-Version parameter to 207.0 or later available versions. Otherwise, an error is returned.

  • Default values for customerAcceptanceDate and serviceActivationDate are set as follows.

serviceActivationDate(SA) specifiedserviceActivationDate (SA) NOT specified
customerAcceptanceDate (CA) specifiedSA uses value in the request call; CA uses value in the request callCA uses value in the request call;SA uses CE as default
customerAcceptanceDate (CA) NOT specifiedSA uses value in the request call; CA uses SA as defaultSA and CA use CE as default

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
contractEffectiveDatedateRequired

Effective contract date for this subscription, as yyyy-mm-dd.

subscribeToRatePlanslist of objectsRequired
Container for one or more rate plans for this subscription.
termTypestringRequired

Possible values are: TERMED, EVERGREEN.

accountKeystringOptional

Customer account number or ID.

You must specify the account information either in this field or in the previewAccountInfo field with the following conditions:

  • If you already have a customer account, specify the account number or ID in this field.
  • If you do not have a customer account, provide account information in the previewAccountInfo field.
customerAcceptanceDatedateOptional

The date on which the services or products within a subscription have been accepted by the customer, as yyyy-mm-dd.

Default value is dependent on the value of other fields. See Notes section for more details.

documentDatedateOptional

The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.

  • If this field is specified, the specified date is used as the billing document date.
  • If this field is not specified, the date specified in the targetDate is used as the billing document date.
includeExistingDraftDocItemsbooleanOptional

Specifies whether to include draft invoice items in subscription previews. Values are:

  • true (default). Includes draft invoice items in the preview result.
  • false. Excludes draft invoice items in the preview result. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 207.0 or a later available version.
initialTermlongOptional

Duration of the first term of the subscription, in whole months. If termType is TERMED, then this field is required, and the value must be greater than 0. If termType is EVERGREEN, this field is ignored.

initialTermPeriodTypestringOptional

The period type of the initial term.

Supported values are:

  • Month
  • Year
  • Day
  • Week

The default period type is Month.

invoiceOwnerAccountKeystringOptional

Invoice owner account number or ID.

Note: This feature is in Limited Availability. If you wish to have access to the feature, submit a request at Zuora Global Support.

notesstringOptional<=1000 characters
The notes for the subscription.
previewAccountInfoobjectOptional

A container for providing a customer account information if you do not have an existing customer account. This customer account information is only used for subscription preview.

You must specify the account information either in this field or in the accountKey field with the following conditions:

  • If you already have a customer account, specify the account number or ID in the accountKey field.
  • If you do not have a customer account, provide account information in this field.
previewTypeenumOptionalDefaults to LegalDoc

The type of preview you will receive.

Note: If your API minor version is earlier than 206.0 or you specify the Zuora-Version header for this request to 206.0 or earlier, the following values are supported for the previewType field:

  • InvoiceItem (default)
  • ChargeMetrics
  • InvoiceItemChargeMetrics
Allowed values:
serviceActivationDatedateOptional

The date on which the services or products within a subscription have been activated and access has been provided to the customer, as yyyy-mm-dd.

Default value is dependent on the value of other fields. See Notes section for more details.

skipTaxbooleanOptionalDefaults to false

If set to true, the system will bypass the tax calculation during subscription preview.

targetDatedateOptional

Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.

Note: This field is only available if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 207.0 or a later available version.

termStartDatedateOptional

The date on which the subscription term begins, as yyyy-mm-dd. If this is a renewal subscription, this date is different from the subscription start date.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
chargeMetricsobjectOptional
Container for charge metrics.
contractedMrrdoubleOptional
Monthly recurring revenue of the subscription.
creditMemoobjectOptional

Container for credit memos.

Note: This container is only available if you are on the latest Zuora API version or you set the Zuora-Version request header to 207.0 or a later available version, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

documentDatedateOptional

The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.

  • If this field is specified, the specified date is used as the billing document date.
  • If this field is not specified, the date specified in the targetDate is used as the billing document date.
invoiceobjectOptional

Container for invoices.

Note: This field is only available if you set the Zuora REST API minor version to 207.0 or a later available version in the request header. Also, the response structure is changed and the following invoice related response fields are moved to this invoice container:

  • amount
  • amountWithoutTax
  • taxAmount
  • invoiceItems
successbooleanOptional

Returns true if the request was processed successfully.

targetDatedateOptional

Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.

Note: This field is only available if you set the Zuora REST API minor version to 207.0 or a later available version in the request header.

taxAmountdoubleOptional
Tax amount on the invoice.
totalContractedValuedoubleOptional
Total contracted value of the subscription.

Errors

4XX
Client Request Error
500
Internal Server Error